#include <gtk/gtk.h>
#include "platform-gtk.h"

#if !GLIB_CHECK_VERSION(2,28,0)

void g_slist_free_full (GSList *list, GDestroyNotify free_func)
{
    g_slist_foreach (list, (GFunc)free_func, NULL);
    g_slist_free (list);
}

#endif


#if !GTK_CHECK_VERSION(2,24,0)

int gdk_window_get_height (GdkWindow *window)
{
    int x, y, width, height, depth;

    gdk_window_get_geometry (window,
                             &x,
                             &y,
                             &width,
                             &height,
                             &depth);

    return height;
}

int gdk_window_get_width (GdkWindow *window)
{
    int x, y, width, height, depth;

    gdk_window_get_geometry (window,
                             &x,
                             &y,
                             &width,
                             &height,
                             &depth);

    return width;
}

#endif


#if !GTK_CHECK_VERSION(2,24,0)

struct GtkComboBoxText {
    GtkComboBox cb;
};

GtkWidget *gtk_combo_box_text_new (void)
{
    auto store = gtk_list_store_new(1, G_TYPE_STRING);
    auto combo_box = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    g_object_unref(store);
    auto cell = gtk_cell_renderer_text_new();
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(combo_box), cell, TRUE);
    gtk_cell_layout_add_attribute(GTK_CELL_LAYOUT(combo_box), cell, "text", 0);

    return combo_box;
}

GtkWidget *gtk_combo_box_text_new_with_entry (void)
{
    auto store = gtk_list_store_new(1, G_TYPE_STRING);
    auto combo_box = gtk_combo_box_entry_new_with_model(GTK_TREE_MODEL(store), 0);
    g_object_unref(store);
    auto cell = gtk_cell_renderer_text_new();
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(combo_box), cell, TRUE);

    return combo_box;
}

void gtk_combo_box_text_append_text (GtkComboBoxText *combo_box, const gchar *text)
{
    auto store = gtk_combo_box_get_model(GTK_COMBO_BOX(combo_box));
    gtk_list_store_insert_with_values(GTK_LIST_STORE(store), NULL, -1, 0, text, -1);
}

#endif


#if !GTK_CHECK_VERSION(2,22,0)

GtkWidget *gtk_message_dialog_get_message_area (GtkMessageDialog *message_dialog)
{
    auto area2 = gtk_dialog_get_content_area(GTK_DIALOG(message_dialog));

    // first child of dialog content area should be hbox
    auto children1 = gtk_container_get_children(GTK_CONTAINER(area2));
    auto child1 = g_list_nth_data(children1, 0);

    // second child of hbox should be vbox
    auto children2 = gtk_container_get_children(GTK_CONTAINER(child1));
    auto child2 = g_list_nth_data(children2, 1);

    return GTK_WIDGET(child2);
}

#endif

